Subject: IPP> PRO interoperability clarification request from TES

From: "Zehler,Peter" <[email-masked]>
Date: Thu, 16 Oct 1997 13:49:42 PDT

All,
   After some testing of two independent implementations of IPP I
believe 
a clarification is required in the protocol specification.  (IMHO)For
simplicity 
in parsing I hope that xxx-attributes-tags should only be sent when an 
xxx-attribute-sequence is present in the IPP payload.  I see no reason 
for a xxx-attributes-tags by itself.  A data-tag by itself makes sense
to 
delimit an IPP header in a data stream. Attached(PROP I) are the 
modifications I suggest.
   If we intend to allow xxx-attributes-tags without any associated
attributes
I believe clarification is needed.  I have attached(PROP II)
modification to
clarify this.
  Of course there is always "leave it alone"(PROP III). 

Pete

PS Pat: Let me know when your address is updated in the IPP DL. I'll
             stop cc'ing you. 
_________________________
PROP I

Clarification in ipp-pro-971014.doc suggested:
Section 3.1:
  picture of encoding stays the same
  line 140: 
     "unsupported-job. The xxx-attributes-tag and xxx-attribute-sequence

      may be omitted if the operation has no attributes or it may be"...
    change to 
     "unsupported-job. The xxx-attributes-tag and xxx-attribute-sequence

      MUST be omitted if the operation has no attributes or it may be"
...
  line 145:
     "An xxx-attributes-sequence consists of zero or more
compound-attributes."
    change to
     "An xxx-attributes-sequence consists of one or more
compound-attributes."
  line 182(parsing diagram):
"|           empty or rest of attribute        |   x bytes |"
    change to 
"|                     rest of attribute        |   x bytes |"
section 3.2:
  line 202(syntax of encoding):
     "xxx-attribute-sequence = *compound-attribute"
    change to
     "xxx-attribute-sequence = 1*compound-attribute"
section 3.6.1: no change.
_________________________
PROP II
Clarification in ipp-pro-971014.doc suggested:
Section 3.1:
  picture of encoding:
     "|             xxx-attribute-sequence          |   n bytes |"
   change to
     "|             xxx-attribute-sequence          |0 to n bytes|"
  line 140: 
     "unsupported-job. The xxx-attributes-tag and xxx-attribute-sequence

      may be omitted if the operation has no attributes or it may be"...
    change to 
     "unsupported-job. The xxx-attributes-tag and xxx-attribute-sequence

      or just the xxx-attribute-sequence may be omitted if the operation

      has no attributes.  The tag and sequence may be"...
  parsing diagram: no change
section 3.2:
  line 202(syntax of encoding): No change
section 3.6.1:
  line 263 to 266: 
   "The operation-attributes-tag SHALL precede those attributes defined 
     as operation attributes in the model document. The
job-attributes-tag 
     SHALL precede those attributes defined as job attributes in the
model 
     document. The printer-attributes-tag SHALL precede those attributes

     defined as printer attributes in the model document. The 
     unsupported-job-attributes-tag SHALL precede those attributes
defined 
     as unsupported job attributes in the model document
    Change to:
     "Those attributes defined as operation attributes in the model
document 
     SHALL be preceded by the operation-attributes-tag. Those attributes

     defined as job attributes in the model document SHALL be preceded
by 
     the job-attributes-tag. Those attributes defined as printer
attributes in the 
     model document SHALL be preceded by the printer-attributes-tag.
Those 
     attributes defined as unsupported job attributes in the model
document 
     SHALL be preceded by the unsupported-job-attributes-tag.  Any of
the tags 
     may appear without any associated attributes."

__________________________________        
Email:   [email-masked]
US Mail: Peter Zehler
         Xerox Corp.
         800 Phillips Rd.
         Webster NY, 14580-9701
Voice:   (716) 265-8755
FAX:     (716)265-8792
__________________________________        
"I always wanted to be somebody, 
  but I should have been more specific." 
                                         Lily Tomlin
__________________________________